#!/usr/bin/python.exe

# PyBuildWatcher

# using either command line arguments or a configuration file
# watch for new builds on a specified server and copy down to
# specified location.

# BuildWatcher.ini (if used) must be in the same directory as this script.

import sys, getopt, time, os, ConfigParser, ftplib, popen2, time, shutil, glob

def processIni():
    print "Processing BuildWatcher.ini"
    # This will read in the INI file and return all the
    # required values
    os.chdir( 'c:\\BuildWatcher' )
    cfg = ConfigParser.ConfigParser()
    cfg.read( 'BuildWatcher.ini' )
    time.sleep( 2 )
    SERVER = cfg.get( 'General', 'Server' )
    SHARE = cfg.get( 'General', 'Share' )
    LOGIN = cfg.get( 'General', 'Username' )
    PASSWORD = cfg.get( 'General', 'Password' )
    LDIR = cfg.get( 'General', 'Target' )
    #SDIR = cfg.get( 'Product', 'Path' )
    Project = raw_input('Enter Project number (ie 7.0.0): ')
    Bld = raw_input('Enter Build Number: ')
    SDIR = 'Unreleased_Builds\CommonClient\cc' + Project[0] + '\CommonClient' + Project
    EXCL = cfg.get( 'Product', 'Excludes' )
    return SERVER, SHARE, LOGIN, PASSWORD, LDIR, SDIR, EXCL, Bld, Project

def checkForLatest( SERVER, SHARE, LDIR, SDIR ):
    os.chdir( 'x:\\' + SDIR )
    # Get a listing of directories only. Python honours our numbering system, so we can just go to the last one.
    # Currently unknown how it handles -a builds. Worry about that later.

    d = os.listdir( os.getcwd() )
    try:
        d.remove( 'Latest_Accepted.txt')
    except:
        pass
    d.sort()
    bld = d[len(d) - 1]
    
    pollForBuild = True

    while pollForBuild == True:
      try:
        if not os.path.exists( 'c:\\BuildWatcher\\BuildNumber.' + bld ):
            print "Checking for existance of build %s." % bld
            while pollForBuild == True:
                d = os.listdir( os.getcwd() )
                try:
                    d.remove( 'Latest_Accepted.txt')
                except:
                    pass
                d.sort()
                bld = d[len(d) - 1]
                if not os.path.exists( os.path.join( bld, 'Post_Complete.txt' )):
                    print "\tBuild %s is not ready." % bld
                    print "\tSleeping 30 minutes until next attempt."
                    time.sleep( 30 * 60 )
                else:
                    pollForBuild = False

        elif os.path.exists( 'c:\\BuildWatcher\\BuildNumber.' + bld ):
            if os.path.splitext( 'c:\\BuildWatcher\\BuildNumber.' + bld )[1] == '.' + bld:
                print "\tBuild %s has already run. Waiting for a new build." % bld
                print "\tSleeping 30 minutes until next attempt."
                d = os.listdir( os.getcwd() )
                try:
                    d.remove( 'Latest_Accepted.txt')
                except:
                    pass
                d.sort()
                oldbld = bld
                bld = d[len(d) - 1]
                time.sleep( 30 * 60 )
                if bld > oldbld:
                    pollForBuild = False
      except OSError:
        pass

    return bld

def doFtpTransfer( SERVER, LDIR, SDIR, EXCL ):
    os.chdir( 'c:\\BuildWatcher' )
    cfg = ConfigParser.ConfigParser()
    cfg.read( 'BuildWatcher.ini' )
    time.sleep( 2 )
    WGET = cfg.read( 'General', 'WGet' )
    os.chdir( os.path.join( LDIR, 'downloads' ))
    print "Transferring build."
    if EXCL != "":
        os.spawnv( os.P_WAIT, WGET, [WGET, '-xrN', '-l10', '-X', EXCL, SERVER + '/' + SDIR] )
    else:
        os.spawnv( os.P_WAIT, WGET, [WGET, '-xrN', '-l10', SERVER + '/' + SDIR] )

def doSmbTransfer( bld, SERVER, SHARE, LDIR, SDIR, Ver ):
    
    # Much of this is CC-specific, and should be moved to a function. Depending on the
    # value specified in the INI the appropriate product-specific function can be called.
    
    bldpath = os.path.join( 'x:\\', SDIR )
    bldpath = os.path.join( bldpath, bld )
    os.chdir( bldpath )
    
    # Write out which build we picked up. So next time we can make sure that it's this or later.
    #b = file( os.path.join( LDIR, 'BuildNumber.' + bld ), 'w' )
    #b.close()

    cfg = ConfigParser.ConfigParser()
    cfg.read( 'c:\\BuildWatcher\\BuildWatcher.ini' )
    try:
        # This is only required for AT layouts
        AT_LOCATION = cfg.get( 'General', 'AutoTest' )
        # Scripts should get their own INI entry, or the client should be queried
        localdir = os.path.join( AT_LOCATION, 'CD_IMAGE\\TESTROOT' )
        if not os.path.exists( os.path.join( localdir, 'SCRIPTS' )): os.mkdir( os.path.join( localdir, 'SCRIPTS' ))
        print "Updating scripts."
        localdir = os.path.join( AT_LOCATION, 'CD_IMAGE\\TESTROOT' )
        p4dir = cfg.get( 'Product', 'P4Dir' )
        p4base = '/cygdrive/c/depot'
        os.chdir( os.path.join( p4base, p4dir ))
        os.system( 'cp -rf * %s' % os.path.join( AT_LOCATION, 'CD_IMAGE/TESTROOT/SCRIPTS' ) )
        # Python path isn't available at this point, so temporarily make the required module available in the current path.
        #if not os.path.exists( os.path.join( localdir, 'SCRIPTS/Common/GetRegistryData.py' )):
        #    shutil.copy2( os.path.join( localdir, 'SCRIPTS/Common/GetRegistryData.py' ), os.path.join( localdir, 'SCRIPTS/BuildAcceptance' ))
    except ConfigParser.NoOptionError:
        localdir = LDIR

    if not os.path.exists( os.path.join( localdir, 'INSTALL' )): os.mkdir( os.path.join( localdir, 'INSTALL' ))
    if not os.path.exists( os.path.join( localdir, 'INSTALL/CC' )): os.mkdir( os.path.join( localdir, 'INSTALL/CC' ))
    if not os.path.exists( os.path.join( localdir, 'INSTALL/SS' )): os.mkdir( os.path.join( localdir, 'INSTALL/SS' ))
    if not os.path.exists( os.path.join( localdir, 'INSTALL/CC/FILES' )): os.mkdir( os.path.join( localdir, 'INSTALL/CC/FILES' ))
    if not os.path.exists( os.path.join( localdir, 'INSTALL/BB-DEBUG' )): os.mkdir( os.path.join( localdir, 'INSTALL/BB-DEBUG' ))
    if not os.path.exists( os.path.join( localdir, 'TOOLS' )): os.mkdir( os.path.join( localdir, 'TOOLS' ))
    if not os.path.exists( os.path.join( localdir, 'SUPPORT' )): os.mkdir( os.path.join( localdir, 'SUPPORT' ))
    if not os.path.exists( os.path.join( localdir, 'SUPPORT/MANIFESTS' )): os.mkdir( os.path.join( localdir, 'SUPPORT/MANIFESTS' ))

    # Special case files should get their own INI entry
    # separateReqFiles = ( 'CCAPP.EXE' )
    eachFile = 'CCAPP.EXE'
    #for eachFile in separateReqFiles:
    #   os.chdir( bld )
    #shutil.copy( os.path.join( bldpath + '\\MergeModules\\ccCommon', eachFile ), os.path.join( localdir, 'INSTALL\\CC\\FILES' ))
    os.system('xcopy /E /Y /R /Q /I %s\\MergeModules\\ccCommon\\%s %s\\INSTALL\\CC\\FILES' % (bldpath, eachFile, localdir))
    
    # Could do this Pythonically, but system commands are so much faster for now...
    os.chdir( bldpath )
    print "Copying build distribution. Please wait."
    if not os.path.exists( os.path.join( bldpath, 'Test\\Install\\Support\\MSI\\WindowsInstaller-KB893803-v2-x86.exe' )):
        print "Copying Windows Installer update."
        shutil.copy2( os.path.join( bldpath, 'Test\\Install\\Support\\MSI\\WindowsInstaller-KB893803-v2-x86.exe' ), os.path.join( localdir, 'INSTALL\\MS' ))
    print "Copying mergemodules."
    os.system( 'xcopy /E /Y /R /Q /I MergeModules\\*.msi "%s\\INSTALL\\CC"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I MergeModules\\ccCmn64\\* "%s\\INSTALL\\CC\\ccCmn64"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I MergeModules\\ccCommon\\* "%s\\INSTALL\\CC\\ccCommon"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I MergeModules\\ccPxyCre\\* "%s\\INSTALL\\CC\ccPxyCre"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I MergeModules\\ccPxyExt\\* "%s\\INSTALL\\CC\\ccPxyExt"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I Test\\MergeModules\\*.msi "%s\\INSTALL\\CC"' % localdir )
    os.system( 'xcopy /E /Y /R /Q /I Test\\MergeModules\\ccTestNAV\\* "%s\\INSTALL\\CC"' % localdir )
    BBVer = Ver[2:]
    if Ver[0] == '6':
        os.system( 'xcopy /E /Y /R /Q /I x:\\Unreleased_Builds\\BehaviorBlocking\\BB3.%s\\%s\\MSI\\* "%s\\INSTALL\\CC"' % ( BBVer, bld, localdir ))
    print "Copying SymNetDrive."
    os.system( 'xcopy /E /Y /R /Q /I Test\\Install\\Support\\SymNetDrv\\* "%s\\INSTALL\\SS"' % localdir )
    #shutil.copy2( os.path.join( bldpath, 'Test\\Install\\Support\\LiveUpdate\\LUSetup.exe' ), os.path.join( localdir, 'INSTALL\\SS' ))
    os.system('xcopy /E /Y /R /Q /I %s\\Test\\Install\\Support\\LiveUpdate\\LUSetup.exe %s\\INSTALL\\SS' % (bldpath, localdir))
    print "Copying tools."
    os.system( 'xcopy /Y /R /Q /I Test\\bin\\bin.ira\\*.exe "%s\\TOOLS"' % localdir )
    os.system( 'xcopy /Y /R /Q /I Test\\bin\\bin.ira\\*.dll "%s\\TOOLS"' % localdir )
    os.system( 'xcopy /Y /R /Q /I Test\\bin\\bin.iru\\*.exe "%s\\TOOLS"' % localdir )
    os.system( 'xcopy /Y /R /Q /I Test\\bin\\bin.iru\\*.dll "%s\\TOOLS"' % localdir )
    os.system( 'xcopy /Y /R /Q /I BIN\\bin.iru\\p*.dll "%s\\SUPPORT\\ccProxy"' % localdir)
    if Ver[0] == '6':
        os.system( 'xcopy /E /Y /R /Q MergeModules\\SPBBC32\\SYMSHARE\\MANIFEST\\* "%s\\SUPPORT\\MANIFESTS"' % localdir )
    os.chdir( os.path.join( localdir, 'INSTALL\\CC' ))
    os.system( 'xcopy /Y /R /Q /I ccCommon\\ccScanw.dll "%s\\TOOLS"' % localdir )
    os.system( 'xcopy /Y /R /Q /I ccCommon\\ccDec_abi.dll "%s\\TOOLS"' % localdir )
    # Add the BB test tools so the unit tests can run too.
    if Ver[0] == '6':
        os.system( 'xcopy /Y /R /Q /I x:\\Unreleased_Builds\\BehaviorBlocking\\BB3.%s\\%s\\ntu.x86.vc71.Release\\bin.nonredist\\* "%s\\TOOLS"' % ( BBVer, bld, localdir ))
        os.system( 'xcopy /Y /R /Q /I x:\\Unreleased_Builds\\BehaviorBlocking\\BB3.%s\\%s\\Manifest\\* "%s\\SUPPORT\\BB"' % ( BBVer, bld, localdir ))
        os.system( 'xcopy /Y /R /Q /I x:\\Unreleased_Builds\\BehaviorBlocking\\BB3.%s\\%s\\ntu.x86.vc71.Debug\\bin.nonredist\\BBUMUXSelfTester.exe "%s\\TOOLS"' % ( BBVer, bld, localdir ))
    
    # Special case files should get their own INI entry
    # Copy Debug binaries over
    print "Copying debug binaries. Please wait."
    dbg_binaries = ( 'SPBBCDRV.SYS', 'BBRGEN.DLL', 'SPBBCCLI.DLL', 'SPBBCEVT.DLL', 'UPDMGR.EXE' )
    for eachFile in dbg_binaries:
        if os.path.exists( os.path.join( localdir, 'INSTALL\\BB-DEBUG\\' + eachFile )):
            os.remove( os.path.join( localdir, 'INSTALL\\BB-DEBUG\\' + eachFile ))
        try:
            shutil.copy( os.path.join( bldpath, 'BIN\\bin.idu\\' + eachFile ), os.path.join( localdir, 'INSTALL\\BB-DEBUG' ))
        except IOError:
            f = file( 'c:\\BuildWatcher\\Errors\\Errors.log', 'a' )
            f.write( eachFile + '\n' )
            f.close()


if __name__ == '__main__':

    SERVER=SHARE=LOGIN=PASSWORD=LDIR=SDIR=EXCLUDES = ""

    os.chdir( 'c:\\BuildWatcher' )

    if len( sys.argv ) == 1:
        if not os.path.exists( 'c:\\BuildWatcher\\BuildWatcher.ini' ):
            print "If no command-line arguments are specified, BuildWatcher.ini must be present."
            sys.exit()
        else:
            SERVER, SHARE, LOGIN, PASSWORD, LDIR, SDIR, EXCLUDES, bld, Project = processIni()
    else:
        # Handle command line options
        opts, args = getopt.getopt( sys.argv[1:], "s:h:l:p:t:c:x:" )
        for o, v in opts:
            if o == "-s": SERVER = v
            elif o == "-h": SHARE = v
            elif o == "-l": LOGIN = v
            elif o == "-p": PASSWORD = v
            elif o == "-t": LDIR = v
            elif o == "-c": SDIR = v
            elif o == "-x": EXCLUDES = v

    if os.path.exists('d:\\AT_Tools\\CD_IMAGE\\TestCases.ini'):
        os.remove('d:\\AT_Tools\\CD_IMAGE\\TestCases.ini')
    shutil.copy2('d:\\AT_Tools\\CD_IMAGE\\TestCases' + Project + '.ini', 'd:\\AT_Tools\\CD_IMAGE\\TestCases.ini')

    f = file( 'c:\\BuildWatcher\\Build', 'w' )
    f.write( bld )
    f.close()
    p = file( 'c:\\BuildWatcher\\Version' , 'w')
    p.write(Project)
    p.close()
    
    if LDIR == "":
        if not os.path.exists( os.path.join( '.', 'downloads' )):
            os.mkdir( os.path.join( '.', 'downloads' ))
        LDIR = os.path.join( '.', 'downloads' )
    else:
        if not os.path.exists( os.path.join( LDIR, 'downloads' )):
            os.mkdir( os.path.join( LDIR, 'downloads' ))
    
    #if LOGIN == "":
    #    doFtpTransfer( SERVER, LDIR, SDIR, EXCLUDES )
    #else:
    #bld = checkForLatest( SERVER, SHARE, LDIR, SDIR )
    print "Attempting to build CC" + Project + " build number " + bld
    if bld:
        # Do a Perforce sync before getting the latest build.
        # Make sure we have a valid Perforce ticket by logging in before syncing
        o, i = popen2.popen2( 'p4 login' )
        time.sleep( 2 )
        i.write( 'stg=ccave\n' )
        os.system( 'p4 sync' )

        # Most of this is no longer used in the function...
        doSmbTransfer( bld, SERVER, SHARE, LDIR, SDIR, Project )
