#!/usr/bin/env python

"""
Build a simple HTML table to display BA components
"""

import os, glob

def cmp(x,y):
    if x[5] > y[5]:
        return 1
    elif x[5] < y[5]:
        return -1
    elif x[5] == y[5]:
        if x[6] > y[6]:
            return 1
        elif x[6] < y[6]:
            return -1
        elif x[6] == y[6]:
            if x[7] > y[7]:
                return 1
            if x[7] < y[7]:
                return -1
            elif x[7] == x[7]:
                return 0
    else:
        return 0
    
def write_body( opsys, fsys, language, component, status ):
    if status == 'P': status = 'pass'
    elif status == 'F': status = 'fail'
    elif status == 'U': status = 'untested'
    component = "<br />".join( component )
    table_body = """
       <tbody>
            <tr id="row2">
                <td>%s<br />
                %s<br />
                %s</td>
                <td>
                    <div class="%s">%s</div>
                </td>
            </tr>""" % ( opsys, fsys, language, status, component )
    return table_body


os.chdir( 'c:\\BuildWatcher\\restmp' )

#if os.path.exists( 'c:\\BuildWatcher\\tmp\\FAILED.html' ): os.remove( 'c:\\BuildWatcher\\tmp\\FAILED.html' )
#if os.path.exists( 'c:\\BuildWatcher\\tmp\\PASSED.html' ): os.remove( 'c:\\BuildWatcher\\tmp\\PASSED.html' )
if os.path.exists( 'c:\\BuildWatcher\\tmp\\RESULTS.html' ): os.remove( 'c:\\BuildWatcher\\tmp\\RESULTS.html' )

files = glob.glob( '*_*' )
files_to_process = len( files )
files.sort(reverse = True)
files.sort(cmp)

#passed = file( 'c:\\BuildWatcher\\tmp\\PASSED.html', 'a' )
#failed = file( 'c:\\BuildWatcher\\tmp\\FAILED.html', 'a' )
results = file( 'c:\\BuildWatcher\\tmp\\RESULTS.html', 'a' )


table_column_header_pass = """
    <thead>
        <tr id="row1">
            <td>Environment</td>
            <td>Results - passed</td>
        </tr>
    </thead>"""
    
table_column_header_fail = """
    <thead>
        <tr id="row1">
            <td>Environment</td>
            <td>Results - failed</td>
        </tr>
    </thead>"""

eachLine = ""; operating_system = ""; file_system = ""
status = ""

table_footer = "</tbody></table>"
table_header = '''<p></p><table class="collapsed" border="3" width="75%%" cellspacing="5" cellpadding="5" summary="Test Results (%s)">''' % status
table_summary = '''<caption class="placeCaption">Components That %s Automated Build Acceptance</caption>''' % status

for eachFile in files:
    if eachFile[5] == '2': operating_system = "Windows 2000"
    elif eachFile[5] == 'P': operating_system = "Windows XP professional"
    elif eachFile[5] == 'H': operating_system = "Windows XP Home"
    elif eachFile[5] == 'M': operating_system = "Windows XP MCE2005"
    elif eachFile[5] == 'V': operating_system = "Windows Vista"
    elif eachFile[5] == '3': operating_system = "Windows Server 2003"
    if eachFile[6] == 'N': file_system = "NTFS"
    elif eachFile[6] == 'F': file_system = "FAT32"
    if eachFile[7] == 'J': language = "Japanese"
    elif eachFile[7] == 'D': language = "Danish"
    elif eachFile[7] == 'C': language = "Chinese"
    elif eachFile[7] == 'P': language = "Portuguese"
    elif eachFile[7] == 'K': language = "Korean"
    else: language = "English"
    
    f = file( eachFile, 'r' )
    if eachFile[0] == 'P':
        status = "Passed"
        table_summary = '''<caption class="placeCaption">Components That %s Automated Build Acceptance</caption>''' % status
        
        results.write( table_header )
        #results.write( table_summary )
        results.write( table_column_header_pass )

        stored = f.readlines()
        results.write( write_body( operating_system, file_system, language, stored, 'P' ))
        #results.write( table_footer )
        
        
    elif eachFile[0] == 'F':
        status = "Failed"
        table_summary = '''<caption class="placeCaption">Components That %s Automated Build Acceptance</caption>''' % status
        
        #results.write( table_header )
        #results.write( table_summary )
        results.write( table_column_header_fail )

        stored = f.readlines()
        results.write( write_body( operating_system, file_system, language, stored, 'F' ))
        results.write( table_footer )
        results.write( '<br />' )
        results.write( '<br />' )
        results.write( '<br />' )
        results.write( '<br />' )
        results.write( '<br />' )


#failed.close()
#passed.close()
results.close()
