#!/usr/bin/env python

import ConfigParser, os, re, time

def collectFileVersionData():
    # Match size digits
    digits = re.compile( '\d+' )
    tsok = re.compile( "Time Stamp OK" )
    version = re.compile( '\d+\.\d+\.\d+\.\d+' )
    
    os.chdir( 'c:\\BuildWatcher' )
    c = ConfigParser.ConfigParser()
    c.read( 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log' )
    
    file_data = {}
    
    for option in c.options( 'File Data' ):
        if option not in ('EMAILPLUGIN.DLL', 'Default.rul', 'Validate.dat' ):
            current = c.get( 'File Data', option )
            e = str( current )
            file_details = []
            
            file_details.append( digits.search( e ).group() )
            dig = float( file_details[0] ) / 1024
            
            file_details.append( '%.2f KB' % dig )
            try:
                file_details.append( version.search( e ).group() )
            except AttributeError:
                file_details.append( 'Missing' )
            try:
                file_details.append( tsok.search( e ).group()[11:] )
            except AttributeError:  # Timestamp is bad
                file_details.append( 'Missing' )
            
            file_data[ option ] = file_details
    
    row = 2
    formatted_data = ''
    
    for eachEntry in file_data:
        formatted_data = formatted_data + '''        <tr id="row%d">
            <td>%s</td>
            <td>%s (%s)</td>
            <td>%s</td>
            <td class="%s">%s</td>
        </tr>\n''' % ( row, eachEntry, file_data[eachEntry][0], file_data[eachEntry][1], file_data[eachEntry][2], file_data[eachEntry][3].lower(), file_data[eachEntry][3] )
        row += 1

    return formatted_data


# Pick up the name of the project being tested. and the build number.
#cfg = ConfigParser.ConfigParser()
#cfg.read( 'c:\\BuildWatcher\\TestBuildWatcher.ini' )
#project = cfg.get( 'Product', 'Project' )
#version = cfg.get( 'Product', 'Version' )
Ver = file('c:\\BuildWatcher\\Version', 'r')
version = Ver.readline()
project = 'CC' + version
f = file( 'c:\\BuildWatcher\\Build', 'r' )
build_number = f.readline()
f.close()

report_header = """
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head>
    <title>Build Acceptance: %s build %s</title>
        <link rel="stylesheet" href="ba_results.css" media="screen" type="text/css">
        <meta http-equiv="Content-type" content="text/html; charset=iso-8859-1">
        <meta http-equiv="Content-Language" content="en-us">
</head>

<body>

<!-- Site navigation menu -->
<ul class="navbar">
    <li><a href="#summary">Test Summary</a>
    <!--<li><a href="#codeVelocity">Code Velocity</a>-->
    <li><a href="#metrics">Defect Metrics</a>
    <li><a href="#changelists">Defects Addressed</a>
    <li><a href="#fileInformation">File Information</a>
    <li><a href="http://automation.corp.symantec.com:8001/mailman/listinfo">Manage Subscriptions</a>
</ul>

<div id="legend">
    Legend:
    <div class="fail">Component failed</div>
    <div class="pass">Component passed</div>
    <div class="untested">Component untested</div>
</div>

<!-- Main content -->
""" % (project, build_number)

os.chdir( 'c:\\BuildWatcher\\tmp' )

# Need to determine global pass/fail criterion.
f = file( 'c:\\BuildWatcher\\restmp\\Status', 'r' )
BA_STATUS = f.readline()
f.close()

# This is the summary heading.
report_summary = """
<div id="header"><h1>Build Acceptance: <span class="%s">%s</span></h1></div>
<h2>%s<br />Build %s</h2>

<p><span class="warning">* For internal testing only! *</span></p>
<p></p>

<hr>
<h2><a name="summary">Test Summary</a></h2>
""" % (BA_STATUS, BA_STATUS.replace( '_', ' ' ), project, build_number)


# Handle passed tests. These are standalone; just need to be separated by <p></p> tags.
# Run BuildHTMLTable.py before this script.
# Read in PASSED.html
#f = file( 'PASSED.html', 'r' )
#p = f.readlines()
#f.close()
#tests_passed = ''.join( p ) + '<p></p>\n'

# Read in FAILED.html
#f = file( 'FAILED.html', 'r' )
#fa = f.readlines()
#f.close()
#tests_failed = ''.join( fa )+ '<p></p>\n'
# There is no UNTESTED.html for AutoTest-based runs

f = file( 'RESULTS.html', 'r' )
fa = f.readlines()
f.close()
tests_results = ''.join( fa )+ '<p></p>\n'

###### Metrics
## IMPORTANT: The image height/width is currently reversed. When the change is made server-side it
## will need to be done here too.
now = time.localtime( time.time() )
week_ago = time.localtime( time.time() - ( 60 * 60 * 24 * 7 ) )
year, month, day, hour, minute, second, weekday, yearday, daylight = now
wyear, wmonth, wday, wour, wminute, wsecond, wweekday, wyearday, wdaylight = week_ago
today = "%04d-%02d-%02d" % ( year, month, day )
prior_week = "%04d-%02d-%02d" % ( wyear, wmonth, wday )

#report_metrics = """<!--<h2><a name="codeVelocity">Code Velocity</a></h2>
#    <p>Coming soon.</p>-->
#<h2><a name="metrics">Defect Metrics</a></h2>
#    <img src="http://nisqa.symantec.com/stattracker/stattrackergraph.php?product_name=COMMON_CLIENT&product_version=%s&start_date=%s&end_date=%s&graph_height=480&graph_width=640&what_graph[open]=on&what_graph[fixed]=on&what_graph[waiting]=on" alt="Defect metrics chart" />
    
""" % (version, prior_week, today)

###### Changelists
#defId = file( 'c:\\BuildWatcher\\tmp\\tmp.txt' ).readlines()
#siebel_defects = []
#etrack_defects = []
#combined_defects = []
#for eachdefect in defId:
#    if eachdefect[1] == '-':    # i.e. 1-123456, this is a Siebel defect
#        siebel_defects.append( eachdefect )
#    else:
#        etrack_defects.append( eachdefect )

#for eachdefect in siebel_defects:
#    combined_defects.append( eachdefect )
#for eachdefect in etrack_defects:
#    combined_defects.append( '<a href="http://engtools.veritas.com/Etrack/readonly_inc.php?incident=%s&sid=etrack">%s</a>' % ( eachdefect, eachdefect ))

#combined_defects = '<br />'.join( combined_defects )
#changelists = """
#<h2><a name="changeLists">Defects addressed</a></h2>
#    %s<br />
#""" % combined_defects
    
    
    
###### File sizes, versions, timestamps
file_data = collectFileVersionData()
report_file_data = """
<h2><a name="fileInformation">File Information</a></h2>
<table class="collapsed" border="3" width="75%%" cellspacing="5" cellpadding="5" summary="File Information">
    <caption class="placeCaption">File Details</caption>
    <thead>
    <tr id="row1">
            <td>Filename</td>
            <td>File Size</td>
            <td>Version</td>
            <td>Timestamp</td>
    </tr>
    %s
        </tbody>
</table>
""" % file_data

manual_report = 'http://components.corp.symantec.com/Common_Client/Build%%20Acceptance/%s/BuildAcceptance_%s_Manual_build_%s.html' % (version, project, build_number)

report_footer = """
<!-- Sign and date the page, it's only polite! -->
<address>For questions on this report contact <a 
href="mailto:tim_short@symantec.com">Tim Short</a>.</address>
</p>Any necessary manual Build Acceptance test results can be found at <a href="%s">this location.</a> Note that manual reports may not be generated for all builds, and may take up to 24 hours to appear.
<p>

</body>
</html>
""" % manual_report

# Now to assemble the whole file
report_filename_final = "BuildAcceptance_%s_build_%s.html" % (project, build_number)
f = file( report_filename_final, 'w' )
print >> f, report_header, report_summary, tests_results, report_file_data, report_footer
f.close()

# Need to remove the BuildAcceptance.log prior to the next run.
Ver = file('c:\\BuildWatcher\\Version', 'r')
version = Ver.readline()
Ver.close()
if os.path.exists('d:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number):
    os.remove('d:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number)
os.rename( 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log', 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number )

# A separate script needs to check this into perforce:1667 and kick off the email notification.
#!/usr/bin/env python

import ConfigParser, os, re, time

def collectFileVersionData():
    # Match size digits
    digits = re.compile( '\d+' )
    tsok = re.compile( "Time Stamp OK" )
    version = re.compile( '\d+\.\d+\.\d+\.\d+' )
    
    os.chdir( 'c:\\BuildWatcher' )
    c = ConfigParser.ConfigParser()
    c.read( 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log' )
    
    file_data = {}
    
    for option in c.options( 'File Data' ):
        if option not in ('EMAILPLUGIN.DLL', 'Default.rul', 'Validate.dat' ):
            current = c.get( 'File Data', option )
            e = str( current )
            file_details = []
            
            file_details.append( digits.search( e ).group() )
            dig = float( file_details[0] ) / 1024
            
            file_details.append( '%.2f KB' % dig )
            try:
                file_details.append( version.search( e ).group() )
            except AttributeError:
                file_details.append( 'Missing' )
            try:
                file_details.append( tsok.search( e ).group()[11:] )
            except AttributeError:  # Timestamp is bad
                file_details.append( 'Missing' )
            
            file_data[ option ] = file_details
    
    row = 2
    formatted_data = ''
    
    for eachEntry in file_data:
        formatted_data = formatted_data + '''        <tr id="row%d">
            <td>%s</td>
            <td>%s (%s)</td>
            <td>%s</td>
            <td class="%s">%s</td>
        </tr>\n''' % ( row, eachEntry, file_data[eachEntry][0], file_data[eachEntry][1], file_data[eachEntry][2], file_data[eachEntry][3].lower(), file_data[eachEntry][3] )
        row += 1

    return formatted_data


# Pick up the name of the project being tested. and the build number.
#cfg = ConfigParser.ConfigParser()
#cfg.read( 'c:\\BuildWatcher\\TestBuildWatcher.ini' )
#project = cfg.get( 'Product', 'Project' )
#version = cfg.get( 'Product', 'Version' )
Ver = file('c:\\BuildWatcher\\Version', 'r')
version = Ver.readline()
project = 'CC' + version
f = file( 'c:\\BuildWatcher\\Build', 'r' )
build_number = f.readline()
f.close()

report_header = """
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head>
    <title>Build Acceptance: %s build %s</title>
        <link rel="stylesheet" href="ba_results.css" media="screen" type="text/css">
        <meta http-equiv="Content-type" content="text/html; charset=iso-8859-1">
        <meta http-equiv="Content-Language" content="en-us">
</head>

<body>

<!-- Site navigation menu -->
<ul class="navbar">
    <li><a href="#summary">Test Summary</a>
    <!--<li><a href="#codeVelocity">Code Velocity</a>-->
    <li><a href="#metrics">Defect Metrics</a>
    <li><a href="#changelists">Defects Addressed</a>
    <li><a href="#fileInformation">File Information</a>
    <li><a href="http://automation.corp.symantec.com:8001/mailman/listinfo">Manage Subscriptions</a>
</ul>

<div id="legend">
    Legend:
    <div class="fail">Component failed</div>
    <div class="pass">Component passed</div>
    <div class="untested">Component untested</div>
</div>

<!-- Main content -->
""" % (project, build_number)

os.chdir( 'c:\\BuildWatcher\\tmp' )

# Need to determine global pass/fail criterion.
f = file( 'c:\\BuildWatcher\\restmp\\Status', 'r' )
BA_STATUS = f.readline()
f.close()

# This is the summary heading.
report_summary = """
<div id="header"><h1>Build Acceptance: <span class="%s">%s</span></h1></div>
<h2>%s<br />Build %s</h2>

<p><span class="warning">* For internal testing only! *</span></p>
<p></p>

<hr>
<h2><a name="summary">Test Summary</a></h2>
""" % (BA_STATUS, BA_STATUS.replace( '_', ' ' ), project, build_number)


# Handle passed tests. These are standalone; just need to be separated by <p></p> tags.
# Run BuildHTMLTable.py before this script.
# Read in PASSED.html
#f = file( 'PASSED.html', 'r' )
#p = f.readlines()
#f.close()
#tests_passed = ''.join( p ) + '<p></p>\n'

# Read in FAILED.html
#f = file( 'FAILED.html', 'r' )
#fa = f.readlines()
#f.close()
#tests_failed = ''.join( fa )+ '<p></p>\n'
# There is no UNTESTED.html for AutoTest-based runs

f = file( 'RESULTS.html', 'r' )
fa = f.readlines()
f.close()
tests_results = ''.join( fa )+ '<p></p>\n'

###### Metrics
## IMPORTANT: The image height/width is currently reversed. When the change is made server-side it
## will need to be done here too.
now = time.localtime( time.time() )
week_ago = time.localtime( time.time() - ( 60 * 60 * 24 * 7 ) )
year, month, day, hour, minute, second, weekday, yearday, daylight = now
wyear, wmonth, wday, wour, wminute, wsecond, wweekday, wyearday, wdaylight = week_ago
today = "%04d-%02d-%02d" % ( year, month, day )
prior_week = "%04d-%02d-%02d" % ( wyear, wmonth, wday )

report_metrics = """<!--<h2><a name="codeVelocity">Code Velocity</a></h2>
    <p>Coming soon.</p>-->
<h2><a name="metrics">Defect Metrics</a></h2>
    <img src="http://nisqa.symantec.com/stattracker/stattrackergraph.php?product_name=COMMON_CLIENT&product_version=%s&start_date=%s&end_date=%s&graph_height=480&graph_width=640&what_graph[open]=on&what_graph[fixed]=on&what_graph[waiting]=on" alt="Defect metrics chart" />
    
""" % (version, prior_week, today)

###### Changelists
#defId = file( 'c:\\BuildWatcher\\tmp\\tmp.txt' ).readlines()
#siebel_defects = []
#etrack_defects = []
#combined_defects = []
#for eachdefect in defId:
#    if eachdefect[1] == '-':    # i.e. 1-123456, this is a Siebel defect
#        siebel_defects.append( eachdefect )
#    else:
#        etrack_defects.append( eachdefect )

#for eachdefect in siebel_defects:
#    combined_defects.append( eachdefect )
#for eachdefect in etrack_defects:
#    combined_defects.append( '<a href="http://engtools.veritas.com/Etrack/readonly_inc.php?incident=%s&sid=etrack">%s</a>' % ( eachdefect, eachdefect ))

#combined_defects = '<br />'.join( combined_defects )
#changelists = """
#<h2><a name="changeLists">Defects addressed</a></h2>
#    %s<br />
#""" % combined_defects
    
    
    
###### File sizes, versions, timestamps
file_data = collectFileVersionData()
report_file_data = """
<h2><a name="fileInformation">File Information</a></h2>
<table class="collapsed" border="3" width="75%%" cellspacing="5" cellpadding="5" summary="File Information">
    <caption class="placeCaption">File Details</caption>
    <thead>
    <tr id="row1">
            <td>Filename</td>
            <td>File Size</td>
            <td>Version</td>
            <td>Timestamp</td>
    </tr>
    %s
        </tbody>
</table>
""" % file_data

manual_report = 'http://components.corp.symantec.com/Common_Client/Build%%20Acceptance/%s/BuildAcceptance_%s_Manual_build_%s.html' % (version, project, build_number)

report_footer = """
<!-- Sign and date the page, it's only polite! -->
<address>For questions on this report contact <a 
href="mailto:tim_short@symantec.com">Tim Short</a>.</address>
</p>Any necessary manual Build Acceptance test results can be found at <a href="%s">this location.</a> Note that manual reports may not be generated for all builds, and may take up to 24 hours to appear.
<p>

</body>
</html>
""" % manual_report

# Now to assemble the whole file
report_filename_final = "BuildAcceptance_%s_build_%s.html" % (project, build_number)
f = file( report_filename_final, 'w' )
print >> f, report_header, report_summary, tests_results, report_metrics, report_file_data, report_footer
f.close()

# Need to remove the BuildAcceptance.log prior to the next run.
Ver = file('c:\\BuildWatcher\\Version', 'r')
version = Ver.readline()
Ver.close()
if os.path.exists('d:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number):
    os.remove('d:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number)
os.rename( 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log', 'd:\\AT_TOOLS\\IPXSHARE\\Logs\\BuildAcceptance.log.' + version + '.' + build_number )

# A separate script needs to check this into perforce:1667 and kick off the email notification.
